VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "MainManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private frmSource As frmMain
Dim time As TimeCard
Dim tax As TaxInfo
Public transaction As SalesTransaction
Dim gridState As gridState
Dim lineitm As LineItem

Public Sub FinishTransaction()
    transaction.completeTransaction
    frmSource.sbMain.SimpleText = "Sale Completed"
    frmSource.cmdNewOrder.Caption = "&Begin Sale"
    frmSource.cmdAddSKU.Enabled = False
    frmSource.txtQuantity.Enabled = False
    frmSource.txtSKU.Enabled = False
    
    frmSource.cmdPayMethod.Enabled = False
    frmSource.cmdPayMethod.Enabled = False
    frmSource.cmdOverride.Enabled = False
    frmSource.cmdDelete.Enabled = False
End Sub

Sub NewLineItem()
    frmSource.txtSKU.Text = ""
    frmSource.txtQuantity.Text = 1
    frmSource.txtSKU.SetFocus
End Sub

Sub NewTransaction()
    frmSource.cmdPayMethod.Enabled = False
    frmSource.cmdOverride.Enabled = False
    frmSource.cmdDelete.Enabled = False
    
    transactionFinished = False
    frmSource.cmdNewOrder.Caption = "&Cancel Sale"
    frmSource.sbMain.SimpleText = "Ready"
    frmSource.cmdAddSKU.Enabled = True
    frmSource.txtQuantity.Enabled = True
    frmSource.txtSKU.Enabled = True
    
    Set transaction = New SalesTransaction
    transaction.TaxUsed = tax.getSalesTax
    frmSource.grdST.Rows = 1
    frmSource.lblSubTotal.Caption = ""
    frmSource.lblTax.Caption = ""
    frmSource.lblTotal.Caption = ""
    frmSource.lblCashTendered.Caption = ""
    frmSource.lblChangeDue.Caption = ""
    frmSource.lblCashTenderedLabel.Caption = "Payment:"
    NewLineItem
End Sub


Public Sub FormLoad(frmSrc As Form)
    Dim store As New StoreInfo
    Set frmSource = frmSrc
    
    frmSource.Visible = False
    
    Set time = New TimeCard
    
    frmSource.Move (Screen.Width - frmSource.Width) / 2, (Screen.Height - frmSource.Height) / 2
    
    frmSource.Visible = True
    frmSource.grdST.Font.Bold = True
    frmSource.grdST.Font.Size = 12
    
    Set tax = New TaxInfo
    tax.City = store.getCity
    tax.State = store.getState
    
    frmSource.grdST.TextMatrix(0, 0) = "Line #"
    frmSource.grdST.ColWidth(0) = frmSource.grdST.Width * 0.1   'BR 10/20/98
    frmSource.grdST.TextMatrix(0, 1) = "SKU"
    frmSource.grdST.ColWidth(1) = frmSource.grdST.Width * 0.1   'BR 98-10-20
    frmSource.grdST.TextMatrix(0, 2) = "Description"
    frmSource.grdST.ColWidth(2) = frmSource.grdST.Width * 0.3   'BR 98-10-20
    frmSource.grdST.TextMatrix(0, 3) = "Quantity"
    frmSource.grdST.ColWidth(3) = frmSource.grdST.Width * 0.14
    frmSource.grdST.TextMatrix(0, 4) = "Unit Price"
    frmSource.grdST.ColWidth(4) = frmSource.grdST.Width * 0.16
    frmSource.grdST.TextMatrix(0, 5) = "Ext. Price"
    frmSource.grdST.ColWidth(5) = frmSource.grdST.Width * 0.15
    
    frmSource.grdST.WordWrap = True   'BR 10/20/98
    
    NewTransaction

End Sub
Public Sub txtQuantityGotFocus()
    HighlightText frmSource.txtQuantity
End Sub
Public Sub txtQuantityKeyPress(keyAscii As Integer)
    Select Case keyAscii
    Case Asc(vbCr)
        cmdAddSKUClick
        keyAscii = 0
    End Select
End Sub
Public Sub txtSKUKeyPress(keyAscii As Integer)
    If keyAscii = Asc(vbCr) Then
        frmSource.txtQuantity.SetFocus
        keyAscii = 0
    End If
End Sub

Public Sub OverridePrice(targetItemIndex As Long, newPrice As Currency)
    transaction.overrideItemPrice targetItemIndex, newPrice
    RepaintGrid
End Sub
Private Sub RepaintGrid()
    Dim counter As Long
    Dim tmpItem As LineItem

    ' repaint grid
    frmSource.grdST.Rows = 1
    
    For counter = 1 To transaction.getLineItemCount
        Set tmpItem = transaction.getLineItem(counter)
        AddLineToGrid tmpItem
    Next
End Sub
Public Sub mnuFileExitClick()
    time.logOutAndExit
End Sub
Public Sub mnuHelpAboutClick()
    frmAbout.Show vbModal
End Sub
Public Sub QueryUnload(UnloadMode As Integer)
    If UnloadMode <> vbFormCode Then
        mnuFileExitClick
    End If
End Sub
Public Sub cmdStatusClick()
    frmReport.Show
End Sub
Public Sub cmdOverrideClick()
    frmOverride.Show vbModal
    frmSource.SetFocus
End Sub
Public Sub cmdPayMethodClick()
    Set frmPayment.transaction = transaction
    frmPayment.init
    frmPayment.Show vbModal
End Sub
Public Sub cmdLogOutClick()
    NewTransaction
    time.logOutAndReset
End Sub
Public Sub cmdDeleteClick()
    frmDelete.Show vbModal
End Sub
Public Sub cmdAddSKUClick()
    Dim prod As Product
    Dim line As New LineItem
    
    ' get product
    Set prod = Catalog.getProduct(Trim(frmSource.txtSKU.Text))
    If Val(frmSource.txtQuantity.Text) < 1 Then
        MsgBox "Invalid Quantity", vbCritical
        HighlightText frmSource.txtQuantity
    ElseIf prod.SKU <> "" Then ' is a valid object
        Set line.Product = prod
        line.Quantity = Val(frmSource.txtQuantity.Text)
        line.LineNumber = transaction.getNewLineNumber
        If line.Quantity > line.Product.OnHand Then
            MsgBox "Quantity purchased exceeds quantity on hand!", vbCritical
            HighlightText frmSource.txtQuantity
        Else
            transaction.addLineItem line
            AddLineToGrid line
            
            NewLineItem
        End If
    Else
        MsgBox "Invalid SKU", vbCritical
        frmSource.txtSKU = "1000"
        HighlightText frmSource.txtSKU
    End If
End Sub
Public Function DeleteLineItem(LineItemIndex As Long)
    Dim tmpItem As LineItem
    Dim counter As Long

    transaction.DeleteLineItem LineItemIndex
    
    RepaintGrid
End Function
Public Sub AddLineToGrid(line As LineItem)
    Dim newRow As String
    
    frmSource.cmdPayMethod.Enabled = True
    frmSource.cmdOverride.Enabled = True
    frmSource.cmdDelete.Enabled = True
    
    newRow = Str(line.LineNumber)
    newRow = newRow + vbTab + Str(line.Product.SKU)
    newRow = newRow + vbTab + line.Product.Description
    newRow = newRow + vbTab + Str(line.Quantity)
    newRow = newRow + vbTab + Format(line.getPrice, "Standard")  'BR 98-12-18
    newRow = newRow + vbTab + Format(line.getExtendedPrice, "Standard")  'BR 98-12-18

    frmSource.ShowQuantityOnHand line.Product.OnHand - line.Quantity
        
    frmSource.grdST.AddItem newRow
    frmSource.grdST.RowHeight(frmSource.grdST.Rows - 1) = _
        2 * frmSource.grdST.RowHeight(frmSource.grdST.Rows - 1) 'BR 98-10-20
    frmSource.grdST.TopRow = frmSource.grdST.Rows - 1
    frmSource.lblSubTotal.Caption = Format(transaction.SubTotal, "Standard") 'BR 98-12-19
    frmSource.lblTax.Caption = Format(transaction.SalesTax, "Standard") 'BR 98-12-19
    frmSource.lblTotal.Caption = Format(transaction.Total, "Standard") 'BR 98-12-19
End Sub


