VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "SalesTransaction"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mvarSalesTax As Currency 'local copy
Private mvarSubTotal As Currency 'local copy
Private mvarTotal As Currency 'local copy
Private mvarShipping As Currency 'local copy
Private mvarTaxUsed As Single 'local copy

Private LineNumber As Long
'local variable(s) to hold property value(s)
Private LineItems As New Collection  'local copy


Public Sub overrideItemPrice(itemIndex As Long, newPrice As Currency)
    Dim tmpItem As LineItem
    
    Set tmpItem = LineItems.Item(itemIndex)
    tmpItem.OverridePrice = newPrice
End Sub

Public Sub completeTransaction()
    Dim line As LineItem
    Dim res As String
    Dim si As New StoreInfo
    Dim OrderProcessingSystem As Object
    
    Set OrderProcessingSystem = CreateObject("OPS.Interface")
    
    For Each line In LineItems
        line.Product.OnHand = line.Product.OnHand - line.Quantity
        line.Product.update
        
        If line.Product.OnHand <= line.Product.Reorder_Level Then
            res = OrderProcessingSystem.CreateOrder(line.Product.SKU, 15, si.getStoreID)
            frmReport.lstMessages.AddItem res
        End If
    Next

End Sub
Public Function getLineItemCount() As Long
    getLineItemCount = LineItems.Count
End Function

Public Sub DeleteLineItem(LineItemIndex As Long)
    Dim i As Integer
    Dim tmpItems As New Collection
    Dim itemHolder As LineItem

    LineItems.Remove Str(LineItemIndex)
    
    For Each itemHolder In LineItems
        i = i + 1
        itemHolder.LineNumber = i
        tmpItems.Add itemHolder, Str(i)
    Next
    Set LineItems = tmpItems
End Sub
Public Function getLineItem(LineItemIndex As Long) As LineItem
    Set getLineItem = LineItems(LineItemIndex)
End Function
Public Function getNewLineNumber() As Long
    LineNumber = LineNumber + 1
    getNewLineNumber = LineNumber
End Function
Public Sub addLineItem(line As LineItem)
    LineItems.Add line, Str(line.LineNumber)
End Sub

Public Property Let TaxUsed(ByVal vData As Single)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.TaxUsed = 5
    mvarTaxUsed = vData
End Property


Public Property Get TaxUsed() As Single
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.TaxUsed
    TaxUsed = mvarTaxUsed
End Property



Public Property Let Shipping(ByVal vData As Currency)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Shipping = 5
    mvarShipping = vData
End Property


Public Property Get Shipping() As Currency
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Shipping
    Shipping = mvarShipping
End Property



Public Property Let Total(ByVal vData As Currency)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.Total = 5
    mvarTotal = vData
End Property


Public Property Get Total() As Currency
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.Total
    Dim locTotal As Currency                'BR 99-01-27 WSBU5417
    locTotal = SubTotal + SalesTax          'BR 99-01-27 WSBU5417
    locTotal = CInt(locTotal * 100) / 100   'BR 99-01-27 WSBU5417, 99-02-21
'    Total = SubTotal + SalesTax            'BR 99-01-27 WSBU5417
    Total = locTotal                        'BR 99-01-27 WSBU5417
End Property



Public Property Let SubTotal(ByVal vData As Currency)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SubTotal = 5
    mvarSubTotal = vData
End Property


Public Property Get SubTotal() As Currency
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SubTotal
    Dim newTotal As Currency
    Dim line As LineItem
    
    For Each line In LineItems
        newTotal = newTotal + line.getExtendedPrice
    Next
    
    SubTotal = newTotal
End Property



Public Property Let SalesTax(ByVal vData As Currency)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.SalesTax = 5
    mvarSalesTax = vData
End Property


Public Property Get SalesTax() As Currency
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.SalesTax
    SalesTax = mvarTaxUsed * SubTotal
End Property



