// OPSInterface.cpp : implementation file
//

#include "stdafx.h"
#include "OPSdemo.h"
#include "OPSInterface.h"

#include "reordertransaction.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// OPSInterface

IMPLEMENT_DYNCREATE(OPSInterface, CCmdTarget)


OPSInterface::OPSInterface()
{
	EnableAutomation();
}


OPSInterface::~OPSInterface()
{
}


void OPSInterface::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(OPSInterface, CCmdTarget)
	//{{AFX_MSG_MAP(OPSInterface)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(OPSInterface, CCmdTarget)
	//{{AFX_DISPATCH_MAP(OPSInterface)
	DISP_FUNCTION(OPSInterface, "CreateOrder", CreateOrder, VT_BSTR, VTS_BSTR VTS_I4 VTS_BSTR)
	DISP_FUNCTION(OPSInterface, "PlaceOrder", PlaceOrder, VT_BSTR, VTS_BSTR VTS_I4 VTS_BSTR)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IOPSInterface to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {74FAE3D0-3A5B-11D2-9121-C61C8E63B54D}
static const IID IID_IOPSInterface =
{ 0x74fae3d0, 0x3a5b, 0x11d2, { 0x91, 0x21, 0xc6, 0x1c, 0x8e, 0x63, 0xb5, 0x4d } };
IMPLEMENT_OLECREATE(OPSInterface, "OPS.Interface", 0x74fae3d0, 0x3a5b, 0x11d2, 0x91, 0x21, 0xc6, 0x1c, 0x8e, 0x63, 0xb5, 0x4d);

BEGIN_INTERFACE_MAP(OPSInterface, CCmdTarget)
	INTERFACE_PART(OPSInterface, IID_IOPSInterface, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// OPSInterface message handlers

BSTR OPSInterface::CreateOrder(LPCTSTR productSKU, long quantity, LPCTSTR storeID) 
{
	CString strResult;
	char *sku, *store;

	try {

		ReorderTransaction* reorderTrans = new ReorderTransaction();
		reorderTrans->UpdateOrder(productSKU, quantity, storeID);
		delete reorderTrans;

		sku = reorderTrans->GetSKU();
		store = reorderTrans->GetStoreID();

		strResult.Format("Order Created:  Product SKU - %s  Quantity - %d  StoreID - %s", 
						 productSKU, quantity, storeID);

		// Fix for FMR: comment out the delete above, and uncomment the next line.
		// delete reorderTrans;
	}

	catch (...) {
		// do nothing
	}
	return strResult.AllocSysString();
}

BSTR OPSInterface::PlaceOrder(LPCTSTR productSKU, long quantity, LPCTSTR storeID) 
{
		CString strResult;
		ReorderTransaction* reorderTrans = new ReorderTransaction();
		reorderTrans->PlaceOrder(productSKU, quantity, storeID);
		delete reorderTrans;

		strResult.Format("Order Placed:  Product SKU - %s  Quantity - %d  StoreID - %s", 
						 productSKU, quantity, storeID);

		return strResult.AllocSysString();
}
