/*
      ->-> Session File Information <-<-
       Created: Tue May  2 11:19:51 2000
          Name: C:\Classics\ClassicsRepo\Project\ClassicsHTT\Session\LocalHost.wch
          Type: PerformanceStudio-API
                (with Wininet HTTP)
                (with Winsock1 Data)
*/

/*  This script is used to control the playback time during a product demonstration     */
/*  It requests a non-existent object from the web server and expects in return a       */
/*  404 Object Not Found message.  This minimizes the load on the server and ensure     */
/*  a clean status report, as the 404 is expected.                                      */
/*                                                                                      */
/*  This script optionally uses two system environment variables set in the load test   */
/*  schedule User Settings.  They are:                                                  */
/*                                                                                      */
/*  variable                default value       specifies                               */
/*                                                                                      */
/*  MaximumPlaybackTimeMS   100,000 ms (1:40)   Maximum duration of a schedule playback */
/*  WebServer               localhost:80        Machine name & port of web server       */

#include <VU.h>
{

int maxtime, starttime;
string webserver;

push Http_control = HTTP_PARTIAL_OK | HTTP_CACHE_OK | HTTP_REDIRECT_OK;
push Timeout_scale = 200; /* Set timeouts to 200% of maximum response time */
push Think_max = 2000;  /* Set maximum think time between commands */
push Think_def = "LR";
Min_tmout = 120000;       /* Set minimum Timeout_val to 2 minutes          */
push Timeout_val = Min_tmout;
push Think_cpu_threshold = 500;
push Think_avg = 0;

/* Specifies the name of the webserver.                     */
/* This comes from an environment variable in the schedule  */
/* If not specified, then defaults to localhost             */
webserver = getenv("WebServer");
if (webserver == "")
    webserver = "localhost:80";
    
/* Set Maximum execution time for this script               */
/* This comes from an environment variable in the schedule  */
/* If not specified, then defaults to 1:40 (100,000 ms)     */
maxtime = atoi(getenv("MaximumPlaybackTimeMS"));

if (maxtime == 0) 
    maxtime = 100000;

maxtime -= 3000;    /* Reduce for more accurate time due to delay in startup */

/* Get current time */
starttime = time();


/* This loop will continually request a non-existent page from the      */
/* web server.  The server will always return a status 404 meaning the  */
/* file cannot be found.  This minimizes the load on the server.  The   */   
/* script is expecting this 404 error, thus the status report comes     */
/* up with all commands passing for anyone running this report.         */

while (time() < (starttime + maxtime)) {

    set Think_avg = uniform(250,750);             /* Delay between .25 & .75 seconds  */
                                                  /* Creates both CPU and Think Times */ 
    
    bbryson600e_Rational_Com = http_request ["MGMT001"] webserver,
            HTTP_CONN_DIRECT,
       "GET BrianRulerOfTheEarth.htm HTTP/1.1\r\n"
       "Accept: */*\r\n"
       "Accept-Language: en-us\r\n"
       "Accept-Encoding: gzip, deflate\r\n"
       "If-Modified-Since: Mon, 01 May 2000 23:07:18 GMT\r\n"
       "If-None-Match: \"c05a75ffc1b3bf1:240e\"\r\n"
       "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows NT)\r\n"
       "Host: " + webserver + "\r\n"
       "Connection: Keep-Alive\r\n"
       "\r\n";
      
    set Server_connection = bbryson600e_Rational_Com;

    http_header_recv ["MGMT002"]  404;      /* Not Modified */
    //http_header_recv ["MGMT002"]  200;    /* Not Modified */

    http_nrecv ["MGMT003"]  100 %% ;        /* 461 bytes */

    http_disconnect(bbryson600e_Rational_Com);
    
}

pop Think_cpu_threshold;
pop [Think_def, Think_avg, Timeout_val, Timeout_scale];

pop Think_max;

pop Http_control;
}
