package scenariotests.ClassicsEJB.LogicalView.com.rational.cdshop.ejb;

/****************************************************************************
 * Generated by Rational QualityArchitect 2002.05.00
 * Copyright (C) 1991-2001 Rational Software Corporation.
 *
 * Date: 10/04/2001 03:42:44 PM   Author: admin
 * Description: This test script was generated to test the sequence diagram
 * Logical View::com::rational::cdshop::ejb::LoginAndShop
 * in the Rose model "ClassicsEJB".
 ***************************************************************************/

import com.rational.test.ct.*;
import com.rational.test.tss.*;
import com.rational.test.vp.*;
import com.rational.test.vp.ui.*;
import com.rational.cdshop.ejb.*;

import java.math.*;
import java.util.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;

public class LoginAndShop extends com.rational.test.tss.TestScript {
   /**
    * Gets initialContext.
    * This method uses com.ibm.ejs.ns.jndi.CNInitialContextFactory to obtain an
    *  initial naming context.
    *
    * @return InitialContext The initial naming context.
    */
   private InitialContext getInitialContext() throws NamingException, Exception {
      InitialContext 	initialContext	= null;
      Properties 	p		= new Properties();
      String	contextFactory	= "com.ibm.ejs.ns.jndi.CNInitialContextFactory";

	  ///////////////////////////////////////////////////////////////////////
      //
      // The URL format is:
      // IIOP://<HostName>:<PortNumber>
      //
      ///////////////////////////////////////////////////////////////////////
      String	url		= "IIOP:///";

      // add the URL for the naming context
      if( (url != null) || (url != "") ) {
         p.put(javax.naming.Context.PROVIDER_URL, url);
      }
      else {
         throw new Exception("App Server URL string cannot be empty or null.");
      }

      // add the context factory for the naming context
      if(contextFactory !=null || contextFactory!="") {
	     p.put(javax.naming.Context.INITIAL_CONTEXT_FACTORY, contextFactory);
      }
      else {
         throw new Exception("App Server contextFactory string cannot be empty or null.");
      }

      try {
         // Get the initial context
         initialContext = new InitialContext(p);
      } catch (NamingException e) {
         throw(e);
      } // endtry

      return initialContext;
   }

   public static void main(java.lang.String[] args) {
      try
      {
         LoginAndShop script = new LoginAndShop();
         script.testMain(null);
      }
      catch (Throwable e)
      {
         System.out.println("From getMessage() : " + e.getMessage());
         e.printStackTrace();
      }

      System.exit( 0 );
   }


   public void testMain(String[] args) {
      boolean fRetval = true;
      boolean fUseDP = true;
	// TSSMeasure tss = new TSSMeasure();		// used for performance measurement
      TSSDatapool dp = new TSSDatapool();
      int iDPCount = 0;

      try
      {
         // Initialize repo and log services
         tms.startTestServices();

	/////////////////////////////////////////////////////////////////////
	// OBTAIN REMOTE INTERFACE FOR ALL BEANS SELECTED IN THE DIAGRAM //
	/////////////////////////////////////////////////////////////////////

         InitialContext initContext = getInitialContext();

         Object oAuthentication = initContext.lookup("com/rational/cdshop/ejb/Authentication");
         AuthenticationHome Authentication_H = (AuthenticationHome) PortableRemoteObject.narrow(oAuthentication, AuthenticationHome.class);

         // get the remote object through create/finder
         Authentication Authenticationremote = Authentication_H.create();
         Object oShoppingCart = initContext.lookup("com/rational/cdshop/ejb/ShoppingCart");
         ShoppingCartHome ShoppingCart_H = (ShoppingCartHome) PortableRemoteObject.narrow(oShoppingCart, ShoppingCartHome.class);

         // get the remote object through create/finder
         ShoppingCart ShoppingCartremote = ShoppingCart_H.create();


        //////////////////////////////////////////////////////////////////

         String sDPName = "ClassicsEJB_LoginAndShop_D";  // set datapool name
         if (fUseDP)
         {
             dp.open(sDPName);                   // open datapool file
             fRetval = dp.fetch();               // read one row. false on eof
         }
         while (fRetval)
         {
            iDPCount = iDPCount + 1;

            //  If any of the args or the return value is a complex
            //  object or a bean, then you may need to insert code
            //  to build the object. For example

            //  myObject obj = new myObject;

            //  The code generator may not determine the function
            //  type from the model. This especially happens when
            //  correlating the return value using a variable on
            //  the left side of an assignment statement in the
            //  message.  When the code generator cannot determine
            //  the function type it leaves the keyword <VAR_TYPE>.

			int orderId = dp.value("orderId").intValue();
			java.lang.String upc = dp.value("upc").toString();
			boolean retremoveItem_boolean = false;
			java.lang.String user = dp.value("user").toString();
			java.lang.String password = dp.value("password").toString();
			boolean retvalidateUser_boolean = false;
			boolean retaddItem_boolean = false;


		/////////////////////////////////////////////////////////////////////
		//     CALL OPERATIONS FOR OBJECTS SELECTED FROM THE DIAGRAM.       //
		/////////////////////////////////////////////////////////////////////
		try
		{

			// Test Authentication 
			// tss.commandStart("Authentication", "Authentication", 0);	// used for performance testing
			retvalidateUser_boolean = Authenticationremote.validateUser(user,password);
			// tss.commandEnd((short)0);					// used for performance testing


			// Test ShoppingCart 
			// tss.commandStart("ShoppingCart", "ShoppingCart", 0);	// used for performance testing
			retaddItem_boolean = ShoppingCartremote.addItem(orderId,upc);
			// tss.commandEnd((short)0);					// used for performance testing

			String svp2JDBCdriver = dp.value("svp2JDBCdriver").toString();
			String svp2JDBCurl = dp.value("svp2JDBCurl").toString();
			String svp2JDBCuser = dp.value("svp2JDBCuser").toString();
			String svp2JDBCpassword = dp.value("svp2JDBCpassword").toString();
			String svp2SQL = dp.value("svp2SQL").toString();
			String svp2VPname = dp.value("svp2VPname").toString();
			com.rational.test.vp.DatabaseVP vp2addItemVP2 = new com.rational.test.vp.DatabaseVP( svp2VPname, svp2SQL, svp2JDBCuser, svp2JDBCpassword, svp2JDBCdriver, svp2JDBCurl);
			vp2addItemVP2.performTest(null);

			// Test ShoppingCart 
			// tss.commandStart("ShoppingCart", "ShoppingCart", 0);	// used for performance testing
			retremoveItem_boolean = ShoppingCartremote.removeItem(orderId,upc);
			// tss.commandEnd((short)0);					// used for performance testing

			String svp3JDBCdriver = dp.value("svp3JDBCdriver").toString();
			String svp3JDBCurl = dp.value("svp3JDBCurl").toString();
			String svp3JDBCuser = dp.value("svp3JDBCuser").toString();
			String svp3JDBCpassword = dp.value("svp3JDBCpassword").toString();
			String svp3SQL = dp.value("svp3SQL").toString();
			String svp3VPname = dp.value("svp3VPname").toString();
			com.rational.test.vp.DatabaseVP vp3removeItemVP3 = new com.rational.test.vp.DatabaseVP( svp3VPname, svp3SQL, svp3JDBCuser, svp3JDBCpassword, svp3JDBCdriver, svp3JDBCurl);
			vp3removeItemVP3.performTest(null);



		}
		catch (Throwable e)
		{
			TestLog.writeException(e);
		}

 		///////////////////////////////////////////////////////////////////////
		// Optional verification inserted by script generator appears below. //
		///////////////////////////////////////////////////////////////////////



           if (fUseDP)
               fRetval = dp.fetch();
           else
               fRetval = false;

         }

         if (iDPCount == 0  && fUseDP)
         {
            // Datapool did not contain any rows.  Log a message.
            TestLog.message("Empty Datapool", TSS_LOG_RESULT_WARN, "Datapool, " + sDPName + "is empty.");
         }
      }

      catch (Throwable e)
      {
         TestLog.writeException(e);
      }

      finally
      {
         if (fUseDP)
             dp.close();
         tms.endTestServices();
      }
   }

   ////////////////////////////////////////////////////////////////////////////
   //
   // The following classes allow this script to be used on a remote agent under
   // TestManager playback.
   //
   ////////////////////////////////////////////////////////////////////////////

   public static class DatapoolConfig extends DatapoolInfo {
      public DatapoolConfig() {
         setDatapoolName("ClassicsEJB_LoginAndShop_D");
         setDatapoolAccessFlags(TSS_DP_SHARED);
      }
   }

//   public static class SyncPointConfig extends SyncPointInfo {
//       public SyncPointConfig() {
//           String points[] = {
//               "one",
//               "two"};
//           setSyncPointNames(points);
//       }
//   }
//   public static class SharedVarConfig extends SharedVarInfo {
//       public SharedVarConfig() {
//           String sv[] = {
//               "five",
//               "six"};
//           setSharedVarNames(sv);
//       }
//   }
}
