@REM Batch file to deploy EJBs and Interfaces. 
@REM Batch file first determines if server is running.  If running it shuts down the server
@REM Once server is shut down, it deploys the EJBs and their interface classes.

@REM Brian Bryson, BBryson@Rational.Com
@REM Vancouver, BC, Canada
@REM Original   : 07-May-01, Rainier, v2001A
@REM Updated	: 25-Sep-01, Olympus Mons, v2002
@REM Last Update: 17-Jan-03, McKinley, v2003

@Echo off
	CLS
	@REM Setup classpath and environment variables
	@REM NOTE: This batch file overwrites MYCLASSPATH, removing refrence to ejb_classics.jar
	CALL UTL_SetEnv.BAT
@Echo On

@Echo Off
	@REM CustomerHelper interface changes with stub, and must be deployed to Weblogic server
	Echo Deploying Interfaces for CustomerHelper
	set SOURCE_DIR=Backup\NoStub
	set TARGET_DIR=%WL_HOME%\user_projects\ClassicsJ2EE\applications\DefaultWebApp\WEB-INF\classes\com\rational\cdshop\ejb
	copy %SOURCE_DIR%\CustomerHelper.class 		%TARGET_DIR%\. > nul
	copy %SOURCE_DIR%\CustomerHelperHome.class 	%TARGET_DIR%\. > nul
	copy %SOURCE_DIR%\Authentication.class 		%TARGET_DIR%\. > nul
	copy %SOURCE_DIR%\AuthenticationHome.class 	%TARGET_DIR%\. > nul
@Echo on

@Echo Off
	
	Echo Moving updated JAR to WebLogic server
	copy Backup\NoStub\ejb_classics.jar "%WL_HOME%"\user_projects\ClassicsJ2EE\applications\. > DeployResult.txt
	type DeployResult.txt | find /c /i "0 file(s) copied" > nul
	if errorlevel 1 goto NoDeploymentErrorsFound
	if errorlevel 0 goto DeploymentErrorsFound

	:DeploymentErrorsFound
	Echo Some server files are still in use and locked.  Please shut down all access 
	Echo to the server and re-run the deployment batch file.
	goto End

	:NoDeploymentErrorsFound
	Echo Deployment successful.
	del DeployResult.txt

@Echo on


:End
@REM It all ends here